
' CONSTANTES gdPicture 

Const PdfPageSizes_PdfPageSizeA4 = 9
Const PdfOcgState_StateOff = 0
Const PdfOcgState_StateOn = 1

'  VARIABLES GLOBALES 

Const gdNameSpace = "GdPicture14"	' pour instancier les objets. Ce nom change  chaque version majeure !
Const gdLicence = "21185375971232559111611147559154793751" 

Dim vScriptPath

'---------- objets :
Dim oLicenseManager	' un objet licence doit exister pour que tous les autres fonctionnent
Dim oPictImaging
Dim oGdPicturePDF
Dim oGdPictureOCR
Dim oAnnotManager
Dim oGdViewer
Dim pictureHdle


'  OCG 

test_OCG	'<<<<<<<<<<<<<<< excution

Sub test_OCG()
	Dim vbErr
	Dim gdErr
	vbErr = False
	gdErr = 0
	
	vbErr = vb_Init_Test	'licence, path fichiers tests
	'vTemplatePDFPath = vScriptPath & "Model"
	'vPDFPath = vScriptPath & "Bulletin"
	
	If Not vbErr Then
		vbErr = vb_create_GdPicturePDF
	End if
	If Not vbErr Then
		gdErr = oGdPicturePDF.NewPDF
		vbErr = vb_GdPicture_TestError(gdErr, "Erreur NewPDF")
	End If
	If Not vbErr Then
		gdErr = oGdPicturePDF.NewPage_2(PdfPageSizes_PdfPageSizeA4)
		vbErr = vb_GdPicture_TestError(gdErr, "Erreur NewPage_2")
	End If
	If Not vbErr Then
		imageName = oGdPicturePDF.AddJpegImageFromFile("petites_fleurs.jpeg")
		vbErr = vb_oGdPicturePDF_GetError("Erreur AddJpegImageFromFile")
	End If
	If Not vbErr Then
		gdErr = oGdPicturePDF.DrawImage(imageName, (oGdPicturePDF.GetPageWidth - 100) / 2, (oGdPicturePDF.GetPageHeight - 100) / 2, 100, 100)
		vbErr = vb_GdPicture_TestError(gdErr, "Erreur DrawImage")
	End If
	If Not vbErr Then
		ocgId = oGdPicturePDF.NewOCG("Watermark image layer")
		vbErr = vb_oGdPicturePDF_GetError("Erreur NewOCG")
	End If
	If Not vbErr Then
		gdErr = oGdPicturePDF.SetImageOptional(imageName, ocgId)
		vbErr = vb_GdPicture_TestError(gdErr, "Erreur SetImageOptional")
	End If
	If Not vbErr Then
		gdErr = oGdPicturePDF.SetOCGPrintState (ocgId, PdfOcgState_StateOn)
		vbErr = vb_GdPicture_TestError(gdErr, "Erreur SetOCGPrintState")
	End If
	If Not vbErr Then
		gdErr = oGdPicturePDF.SetOCGViewState(ocgId, PdfOcgState_StateOff)
		vbErr = vb_GdPicture_TestError(gdErr, "Erreur SetOCGViewState")
	End If
	If Not vbErr Then
		gdErr = oGdPicturePDF.SaveToFile(vScriptPath & "OCG_bug_demo.pdf")
		vbErr = vb_GdPicture_TestError(gdErr, "Erreur SaveToFile")
	End If
	
	If TypeName(oGdPicturePDF) <> "Nothing" Then
		oGdPicturePDF.Dispose
		Set oGdPicturePDF = Nothing
	End If
	
End Sub

'  COMMUN 

Function vb_Init_Test()
	On Error Resume Next
	Dim vbErr
	vbErr = False
	
	vbErr = vb_License_Register	' licence
	
	If Not vbErr Then
		vScriptFullName = WScript.ScriptFullName
		vpos = InStrRev (vScriptFullName,"\")
		vScriptPath = Left (vScriptFullName, vpos)
		'MsgBox vScriptPath
	End if
	
	vb_Init_Test = vbErr
End Function

'  OBJETS GLOBAUX 

' =================================================================================================================
' vb_License_Register
' Un objet licence doit exister pour que tous les autres fonctionnent
' Comme on n'est pas dans une appli, je suppose qu'il suffit de le crer une seule fois dans le contexte vb
' =================================================================================================================

Function vb_License_Register()
	On Error Resume Next
	Dim vbErr
	vbErr = False
	' Set oLicenseManager = Nothing
	If TypeName(oLicenseManager) = "Empty" Or TypeName(oLicenseManager) = "Nothing" Then ' objet pas encore cr
		Set oLicenseManager = CreateObject(gdNameSpace & ".LicenseManager")
		If TypeName(oLicenseManager) = "Empty" Or TypeName(oLicenseManager) = "Nothing" Then
			vbErr = vb_SetError_Local (-1 , "Erreur en crant une instance de " & Const_gdNameSpace & ".LicenseManager")
		Else
			registered = oLicenseManager.RegisterKey(gdLicence)
			If Not registered Then
				vbErr = vb_SetError_Local (-2 , "Problme de licence")
			End If
		End If	
	End If	
	vb_License_Register = vbErr
End Function

' ========================================= cration objet global GdPictureImaging oPictImaging ================================

' Penser  appeler : oPictImaging.Dispose()  la fin usage
' Utiliser aussi pour chaque image : oPictImaging.ReleaseGdPictureImage(pictureHdle)

Function vb_create_GdPicture()
	On Error Resume Next
	Dim vbErr
	vbErr = false
	Set oPictImaging = Nothing
	
	Set oPictImaging = CreateObject(gdNameSpace & ".GdPictureImaging")	
	If TypeName(oPictImaging) = "Nothing" Then
		vbErr = vb_SetError_Local (-1 , "Erreur en crant une instance de " & gdNameSpace & ".GdPictureImaging")
	End If
	
	vb_create_GdPicture = vbErr
End Function

' ========================================= cration objet global oGdPicturePDF ================================

' Penser  appeler : oGdPicturePDF.Dispose()  la fin usage

Function vb_create_GdPicturePDF()
	On Error Resume Next
	Dim vbErr
	vbErr = false
	Set oGdPicturePDF = Nothing
	
	Set oGdPicturePDF = CreateObject(gdNameSpace & ".GdPicturePDF")	
	' Set oGdPicturePDF = WScript.CreateObject(gdNameSpace & ".GdPicturePDF", "evt_oGdPicturePDF_")	' !!!!!! avec vnements !!!!!
	If TypeName(oGdPicturePDF) = "Nothing" Then
		vbErr = vb_SetError_Local (-1 , "Erreur en crant une instance de " & gdNameSpace & ".GdPicturePDF")
	End If
	
	vb_create_GdPicturePDF = vbErr
End Function


' 
'                                       Utilitaires
' 

' =================================================================================================================
'   Gestion des erreurs gdPicture (facilite criture/gestion)
' =================================================================================================================

Function vb_oGdPicturePDF_GetError(pErrorText)
	On Error Resume Next
	Dim gdErr
	
	gdErr = oGdPicturePDF.GetStat()
	If gdErr = 0 Then
		vb_oGdPicturePDF_GetError = False
		If Err.Number <> 0 Then	' autre erreur vb  v5.0.41_TH
			vb_SetError_Local Err.Number , pErrorText & vbNewLine & Err.Source & " : " & Err.Description
			vb_oGdPicturePDF_GetError = True
		End if
	Else
		vb_oGdPicturePDF_GetError = True
		vb_SetError_Local gdErr , pErrorText
	End If
End Function

' =================================================================================================================
Function vb_oPictImaging_GetError(pErrorText)
	' On Error Resume Next  ' NON, a efface erreur
	Dim gdErr
	
	gdErr = oPictImaging.GetStat()
	If gdErr = 0 Then
		vb_oPictImaging_GetError = False
		If Err.Number <> 0 Then	' autre erreur vb
			vb_SetError_Local Err.Number , pErrorText & vbNewLine & Err.Source & " : " & Err.Description
			vb_oPictImaging_GetError = True
		End if
	Else
		vb_oPictImaging_GetError = True
		vb_SetError_Local gdErr , pErrorText
	End If
End Function

' =================================================================================================================
Function vb_GdPicture_TestError(pErr, pErrorText)
	' On Error Resume Next  ' NON, a efface erreur
	
	If pErr = 0 Then
		vb_GdPicture_TestError = False
		If Err.Number <> 0 Then	' autre erreur vb
			vb_SetError_Local Err.Number , pErrorText & vbNewLine & Err.Source & " : " & Err.Description
			vb_GdPicture_TestError = True
		End if
	Else
		vb_GdPicture_TestError = True
		vb_SetError_Local pErr , pErrorText
	End If
	
End Function

' =================================================================================================================
' vb_SetError_Local - Gestion locale erreur
' Pour tester script SANS 4D
Function vb_SetError_Local(pErrorCode, pErrorText)
	On Error Resume Next
	
	MsgBox "ERREUR " & pErrorCode & " : " & pErrorText

	vb_SetError_Local = True
End Function
